<template>
    <modal
        name="store-customer"
        height="auto"
        :shiftY="0.2"
        @before-open="beforeOpen"
        :clickToClose="false"
        :scrollable="true"
    >
        <div class="modal-header">
            <h5 class="modal-title">Customer</h5>

            <div class="close" @click="$modal.hide('store-customer')">
                <span aria-hidden="true">&times;</span>
            </div>
        </div>

        <div class="modal-body">
            <div class="form-group">
                <label>Name</label>
                <input
                    type="text"
                    v-model="customer.name"
                    class="form-control"
                />
            </div>

            <div class="form-group mt-4">
                <label>Street</label>
                <input
                    type="text"
                    v-model="customer.street"
                    class="form-control"
                />
            </div>
            <div class="form-group mt-4">
                <label>City</label>
                <input
                    type="text"
                    v-model="customer.city"
                    class="form-control"
                />
            </div>
            <div class="form-group mt-4">
                <label>Post Code</label>
                <input
                    type="text"
                    v-model="customer.post_code"
                    class="form-control"
                />
            </div>
        </div>

        <div class="modal-footer">
            <button
                v-if="view == 'create'"
                type="button"
                class="btn btn-success"
                :disabled="
                    !customer.name ||
                        !customer.street ||
                        !customer.city ||
                        !customer.post_code
                "
                @click="create()"
            >
                <i class="fas fa-save pr-2"></i> Create
            </button>

            <button
                v-if="view == 'edit'"
                type="button"
                class="btn btn-success"
                :disabled="
                    !customer.name ||
                        !customer.street ||
                        !customer.city ||
                        !customer.post_code
                "
                @click="update()"
            >
                <i class="fas fa-save pr-2"></i> Update
            </button>

            <button
                v-if="view == 'edit'"
                type="button"
                class="btn btn-danger"
                @click="remove()"
            >
                <i class="fas fa-trash pr-2"></i> Delete
            </button>
        </div>
    </modal>
</template>

<script>
export default {
    props: ["customers"],

    data() {
        return {
            customer: {
                name: null,

                street: null,

                city: null,

                post_code: null
            },

            view: "create"
        };
    },

    methods: {
        beforeOpen(event) {
            event.params.customer
                ? (this.customer = JSON.parse(
                      JSON.stringify(event.params.customer)
                  ))
                : [];

            event.params.view ? (this.view = event.params.view) : [];
        },

        create() {
            axios.post("/api/customers/store", this.customer).then(response => {
                // Close modal
                this.$modal.hide("store-customer");

                // Add customer in list
                this.customers.unshift(response.data);

                this.$emit("customer-create", { customer: response.data });

                // Show notification
                this.$toasted.show(
                    "<i class='fas fa-check mr-2'></i> Customer Succesfully Created"
                );
            });
        },

        update() {
            axios
                .put("/api/customers/" + this.customer.id, this.customer)
                .then(response => {
                    const index = this.customers.findIndex(item => {
                        return response.data.id === item.id;
                    });

                    this.customers.splice(index, 1, response.data);

                    // Close modal
                    this.$modal.hide("store-customer");

                    // Show notification
                    this.$toasted.show(
                        "<i class='fas fa-check mr-2'></i> Customer Succesfully Updated"
                    );
                });
        },

        remove() {
            Vue.toasted.clear();

            this.$toasted.show(
                "<i class='fas fa-trash-alt mr-2'> </i> Delete Customer ?",
                {
                    type: "error",

                    duration: null,

                    action: [
                        {
                            text: "Yes",

                            onClick: (e, toastObject) => {
                                toastObject.goAway(0);

                                axios
                                    .post(
                                        "/api/customers/delete/" +
                                            this.customer.id
                                    )
                                    .then(response => {
                                        this.customers.splice(this.customer, 1);

                                        // Close modal
                                        this.$modal.hide("store-customer");

                                        this.$toasted.show(
                                            "<i class='fas fa-check mr-2'></i> Customer Successfully Deleted !"
                                        );
                                    });
                            }
                        },
                        {
                            text: "Cancel",

                            onClick: (e, toastObject) => {
                                toastObject.goAway(0);
                            }
                        }
                    ]
                }
            );
        }
    }
};
</script>
